package com.huiju.estateagents.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.center.taUser.entity.TaUser;
import com.huiju.estateagents.center.taUser.mapper.TaUserMapper;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.common.CommConstant;
import com.huiju.estateagents.drainage.entity.TaDrainage;
import com.huiju.estateagents.drainage.mapper.TaDrainageMapper;
import com.huiju.estateagents.entity.HelpActivity;
import com.huiju.estateagents.entity.TaBuildingDynamic;
import com.huiju.estateagents.entity.TaNews;
import com.huiju.estateagents.entity.TaPerson;
import com.huiju.estateagents.entity.TaPersonVisitRecord;
import com.huiju.estateagents.entity.TaRecommendCustomer;
import com.huiju.estateagents.entity.TaShareActivity;
import com.huiju.estateagents.mapper.HelpActivityMapper;
import com.huiju.estateagents.mapper.TaBuildingDynamicMapper;
import com.huiju.estateagents.mapper.TaNewsMapper;
import com.huiju.estateagents.mapper.TaPersonMapper;
import com.huiju.estateagents.mapper.TaPersonVisitRecordMapper;
import com.huiju.estateagents.mapper.TaRecommendCustomerMapper;
import com.huiju.estateagents.mapper.TaShareActivityMapper;
import com.huiju.estateagents.service.ITaPersonVisitRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *   服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-07-23
 */
@Service
public class TaPersonVisitRecordServiceImpl extends ServiceImpl<TaPersonVisitRecordMapper, TaPersonVisitRecord> implements ITaPersonVisitRecordService {
	
	@Autowired
	private TaRecommendCustomerMapper taRecommendCustomerMapper;
	
	@Autowired
	private TaPersonVisitRecordMapper personVisitRecordMapper;
	
	@Autowired
	private TaBuildingDynamicMapper taBuildingDynamicMapper;
	
	@Autowired
	private TaShareActivityMapper taShareActivityMapper;
	
	@Autowired
	private HelpActivityMapper helpActivityMapper;
	
	@Autowired
	private TaNewsMapper taNewsMapper;

	@Autowired
	private TaUserMapper taUserMapper;

	@Autowired
	private TaPersonMapper taPersonMapper;

	@Autowired
	private TaDrainageMapper taDrainageMapper;

	/**
	 * 分页获取客户访问记录
	 *
	 * @param pg
	 * @param customerId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getPersonVisitRecordList(IPage<TaPersonVisitRecord> pg, String customerId) {
		TaRecommendCustomer taRecommendCustomer = taRecommendCustomerMapper.selectById(customerId);
		IPage<TaPersonVisitRecord> result = personVisitRecordMapper.getPersonVisitRecordList(pg,taRecommendCustomer.getPersonId());
		List<TaPersonVisitRecord> records = result.getRecords();
		records.forEach(e -> {
			//获取活动标题
			if ("activity".equals(e.getEventType()) && null != e.getTargetId()){
				TaBuildingDynamic taBuildingDynamic = taBuildingDynamicMapper.selectById(e.getTargetId());
				if (null != taBuildingDynamic){
					e.setActivityName(taBuildingDynamic.getTitle());
				}
				
			}
			//获取拼团标题
			if ("group".equals(e.getEventType()) && null != e.getTargetId()){
				TaShareActivity taShareActivity = taShareActivityMapper.selectById(e.getTargetId());
				if (null != taShareActivity){
					e.setActivityName(taShareActivity.getActivityName());
				}
			}
			//获取助力标题
			if ("help".equals(e.getEventType()) && null != e.getTargetId()){
				HelpActivity helpActivity = helpActivityMapper.selectById(e.getTargetId());
				if (null != helpActivity){
					e.setActivityName(helpActivity.getTitle());
				}
			}
			//获取咨询标题
			if ("news".equals(e.getEventType()) && null != e.getTargetId()){
				TaNews taNews = taNewsMapper.selectById(e.getTargetId());
				if (null != taNews){
					e.setActivityName(taNews.getNewsName());
				}
			}
			//获取H5活动标题
			if ("h5".equals(e.getEventType()) && null != e.getTargetId()){
				TaDrainage taDrainage = taDrainageMapper.selectById(e.getTargetId());
				if (null != taDrainage){
					e.setActivityName(taDrainage.getName());
				}
			}
		});
		result.setRecords(records);
		return result;
	}

	@Override
	public IPage<TaPersonVisitRecord> getDrainageVisitRecord(IPage<TaPersonVisitRecord> pg, Integer orgId, String activityName, Integer drainageId, String shareName, String shareTel) {
		IPage<TaPersonVisitRecord> taPersonVisitRecordIPage = personVisitRecordMapper.getDrainageVisitRecord(pg, orgId, activityName, drainageId, shareName, shareTel);
		List<TaPersonVisitRecord> taPersonVisitRecords = taPersonVisitRecordIPage.getRecords();
		taPersonVisitRecords.forEach(e -> {
			TaPerson personInfo = taPersonMapper.selectById(e.getPersonId());
			if (personInfo != null){
				e.setUserName(personInfo.getNickname());
				e.setUserTel(personInfo.getPhone());
			}

			TaUser userShareInfo = taUserMapper.selectById(e.getSharePersonId());
			if (userShareInfo != null){
				e.setShareName(userShareInfo.getUserName());
				e.setShareTel(userShareInfo.getPhone());
			}
		});
		taPersonVisitRecordIPage.setRecords(taPersonVisitRecords);
		return taPersonVisitRecordIPage;
	}
	/**
	 * 分页获取个人中心访客记录
	 *
	 * @param pg
	 * @param userId
	 * @param orgId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getWxVisitRecordList(IPage<TaPersonVisitRecord> pg, Integer userId, Integer orgId) {
		//获取我的访问客户列表
		IPage<TaPersonVisitRecord> result = personVisitRecordMapper.getWxVisitRecordList(pg,userId,orgId, CommConstant.EVENT_H5);
		List<TaPersonVisitRecord> records = result.getRecords();
		//判断是否我的客户状态
		records.forEach(e -> {
			String data = e.getData();
			JSONObject dataJson = JSONObject.parseObject(data);
			String realtyConsultant = dataJson.getString("consultant");
			QueryWrapper<TaRecommendCustomer> queryWrapper = new QueryWrapper();
			queryWrapper.eq("realty_consultant",realtyConsultant);
			queryWrapper.eq("person_id",e.getPersonId());
			TaRecommendCustomer taRecommendCustomer = taRecommendCustomerMapper.selectOne(queryWrapper);
			if (null != taRecommendCustomer){
				//1是我的客户
				e.setMyCustomer(CommConstant.STATUS_NORMAL);
			}
		});
		return result;
	}

	/**
	 * 获取这个人的活动数据列表
	 *
	 * @param userId
	 * @param personId
	 * @param orgId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getWxVisitRecordActivityList(IPage<TaPersonVisitRecord> pg,Integer userId, String personId, Integer orgId) {
		return personVisitRecordMapper.getWxVisitRecordActivityList(pg,userId,personId,orgId,CommConstant.EVENT_H5);
	}

//    @Autowired
//    private TaPersonMapper taPersonMapper;
//    @Autowired
//    private TaPersonVisitRecordMapper taPersonVisitRecordMapper;
//
//    @Override
//    public IPage<TaPerson> selectCustomer(IPage<TaPerson> page){
//        return taPersonMapper.selectCustomer(page);
//    }
//
//    @Override
//    public TaPerson customerInfo(String personId,String consultentId){
//        TaPerson taPerson = taPersonMapper.selectById(personId);
//        taPerson.setVisitRecords(taPersonVisitRecordMapper.visitRecordByPersonId(personId));
//        return taPerson;
//    }



}
